Index: /trunk/SophyaExt/FitsIOServer/fitsautoreader.cc
===================================================================
--- /trunk/SophyaExt/FitsIOServer/fitsautoreader.cc	(revision 2208)
+++ /trunk/SophyaExt/FitsIOServer/fitsautoreader.cc	(revision 2209)
@@ -98,5 +98,6 @@
 	{
 	  int index=0;
-	  for (int k=0; k < inFits_->NbColsFromFits(); k++) 
+          int k;
+	  for (k=0; k < inFits_->NbColsFromFits(); k++) 
 	    {
 	      if (inFits_->ColTypeFromFits(k) != FitsFile::FitsDataType_float)
@@ -112,5 +113,6 @@
 	      {
 		int maxEntries=0;
-		for (int k=0; k < inFits_->NbColsFromFits(); k++) 
+                int k;
+		for ( k=0; k < inFits_->NbColsFromFits(); k++) 
 		  {
 		    if (inFits_->NentriesFromFits(k) > maxEntries ) maxEntries =  inFits_->NentriesFromFits(k); 
Index: /trunk/SophyaExt/FitsIOServer/fitsfile.cc
===================================================================
--- /trunk/SophyaExt/FitsIOServer/fitsfile.cc	(revision 2208)
+++ /trunk/SophyaExt/FitsIOServer/fitsfile.cc	(revision 2209)
@@ -23,5 +23,6 @@
       }
     ColName_ = vector<string>(nbcols);
-     for (int k=0; k < maxName; k++) ColName_[k] = names[k];
+    int k;
+    for (k=0; k < maxName; k++) ColName_[k] = names[k];
     if (dc >0) ddata_ = vector<double>(dc);
     if (fc >0) fdata_ = vector<float>(fc);
@@ -78,5 +79,6 @@
   int bc=0;
   id_  = vector< pair<FitsFile::FitsDataType, int> >(types.size());
-  for (int k= 0; k < types.size(); k++)
+  int k;
+  for (k= 0; k < types.size(); k++)
     {
       switch( types[k] )
@@ -146,5 +148,6 @@
 
   cout << " doubles : " << endl;
-  for (int k=0; k< ddata_.size(); k++)
+  int k;
+  for (k=0; k< ddata_.size(); k++)
     {
       cout << ddata_[k] << " " ;
@@ -153,5 +156,5 @@
 
   cout << " floats : " << endl;
-  for (int k=0; k< fdata_.size(); k++)
+  for (k=0; k< fdata_.size(); k++)
     {
       cout << fdata_[k] << " " ;
@@ -160,5 +163,5 @@
 
   cout << " entiers courts: " << endl;
-  for (int k=0; k< shdata_.size(); k++)
+  for (k=0; k< shdata_.size(); k++)
     {
       cout << shdata_[k] << " " ;
@@ -166,5 +169,5 @@
   cout << endl;
   cout << " entiers : " << endl;
-  for (int k=0; k< idata_.size(); k++)
+  for (k=0; k< idata_.size(); k++)
     {
       cout << idata_[k] << " " ;
@@ -173,5 +176,5 @@
 
   cout << " entiers longs : " << endl;
-  for (int k=0; k< ldata_.size(); k++)
+  for (k=0; k< ldata_.size(); k++)
     {
       cout << ldata_[k] << " " ;
@@ -180,5 +183,5 @@
 
   cout << " chaines carac.  : " << endl;
-  for (int k=0; k< cdata_.size(); k++)
+  for (k=0; k< cdata_.size(); k++)
     {
       cout << cdata_[k] << " " ;
@@ -187,5 +190,5 @@
 
   cout << " bytes : " << endl;
-  for (int k=0; k< bdata_.size(); k++)
+  for (k=0; k< bdata_.size(); k++)
     {
       cout << (char)bdata_[k] << " " ;
Index: /trunk/SophyaExt/FitsIOServer/fitsntuple.cc
===================================================================
--- /trunk/SophyaExt/FitsIOServer/fitsntuple.cc	(revision 2208)
+++ /trunk/SophyaExt/FitsIOServer/fitsntuple.cc	(revision 2209)
@@ -183,5 +183,6 @@
    for (k=0; k<ncols;k++)
      {
-       for(int j = 0; j < nentries; j++) column[j]= dobj_->GetVal(j,k);
+       int j;
+       for(j = 0; j < nentries; j++) column[j]= dobj_->GetVal(j,k);
        os.PutColToFits(k, nentries, column);
      }
Index: /trunk/SophyaExt/FitsIOServer/fitsxntuple.cc
===================================================================
--- /trunk/SophyaExt/FitsIOServer/fitsxntuple.cc	(revision 2208)
+++ /trunk/SophyaExt/FitsIOServer/fitsxntuple.cc	(revision 2209)
@@ -297,5 +297,5 @@
   // table will have 'nrows' rows
   int nrows = dobj_->NEntry();
-  cout << " FITS_XNTuple::WriteToFits : nombre de lignes a ecrire " << nrows << endl;
+  //  cout << " FITS_XNTuple::WriteToFits : nombre de lignes a ecrire " << nrows << endl;
   // get names and values from the join DVList object
   DVList dvl= dobj_->Info();
@@ -337,5 +337,6 @@
        for (k=0; k<dobj_->NDVar();k++)
 	 {
-	   for(int j = 0; j < nrows; j++) dcolumn[j]= dobj_->GetDVal(j,compt);
+           int j;
+	   for(j = 0; j < nrows; j++) dcolumn[j]= dobj_->GetDVal(j,compt);
 	   os.PutColToFits(compt, nrows, dcolumn);
 	   compt++;
@@ -349,5 +350,6 @@
        for (k=0; k<dobj_->NFVar();k++)
 	 {
-	   for(int j = 0; j < nrows; j++) fcolumn[j]= dobj_->GetFVal(j,compt);
+           int j;
+	   for(j = 0; j < nrows; j++) fcolumn[j]= dobj_->GetFVal(j,compt);
 	   os.PutColToFits(compt, nrows, fcolumn);
 	   compt++;
@@ -361,7 +363,7 @@
        for (k=0; k<dobj_->NIVar();k++)
 	 {
-	   for(int j = 0; j < nrows; j++) icolumn[j]= dobj_->GetIVal(j,compt);
-	   cout << " fitsx.. va ecrire la colonne " << endl;
-	   for(int j = 0; j < nrows; j++) cout << icolumn[j] << endl;;
+           int j; 
+	   for(j = 0; j < nrows; j++) icolumn[j]= dobj_->GetIVal(j,compt);
+	   //	   for(j = 0; j < nrows; j++) cout << icolumn[j] << endl;;
 
 	   os.PutColToFits(compt, nrows, icolumn);