Index: trunk/ArchTOIPipe/TestPipes/xsl/processors.xml
===================================================================
--- trunk/ArchTOIPipe/TestPipes/xsl/processors.xml	(revision 2220)
+++ trunk/ArchTOIPipe/TestPipes/xsl/processors.xml	(revision 2238)
@@ -1,4 +1,4 @@
-<!-- Vivien FEBVRE 26/09/2002 -->
-<!-- exemple de fichiers descriptif de processeurs -->
+<!-- Vivien FEBVRE le 26/09/2002 -->
+<!-- exemple de fichier descriptif de processeurs -->
 
 
@@ -9,11 +9,25 @@
 
 
+<processor name="fitsreader" class="FITSTOIReader" include="fitstoirdr.h">   
+<init>
+<param name="fn" type="string" default="test.fits"/>
+</init>
+<connection>
+</connection>
+</processor>
+
+<processor name="fitswriter" class="FITSTOIWriter" include="fitstoiwtr.h">   
+<init>
+<param name="fn" type="string"/>
+</init>
+<connection>
+</connection>
+</processor>
+
 <processor name="smooth" class="DataSmooth" include="smoothtoi.h">   
-
 <init>
 <param name="lsm" type="uint_4"/>
 <param name="deg" type="uint_4"/>
 </init>
-
 <attribute name="DoNotLookAt" methode="DoNotLookAt"> 
 <param name="flag" type="uint_8" default="FlgToiAll"/>
@@ -28,13 +42,193 @@
 <param name="lsmin" type="uint_4" default="0"/>
 </attribute>
-
 <connection>
 <input name="DataIn"/>
 <output name="DataSmooth"/>
 </connection>
-
-</processor>
-
-
+</processor>
+
+<processor name="toi2map" class="TOI2Map" include="toi2map.h">   
+<init>
+<param name="map" type="string"/>
+<param name="wmap" type="string" default="NULL"/>
+</init>
+<attribute name="SetEquinox" methode="SetEquinox"> 
+<param name="actualyear" type="double" default="2000"/>
+</attribute>
+<attribute name="SetCoorIn" methode= "SetCoorIn"> 
+<param name="mfg" type="long" default="TypCoordGalStd"/>
+</attribute>
+<attribute name="SetCoorInChr" methode="SetCoorIn"> 
+<param name="ctype" type="char*"/>
+</attribute>
+<attribute name="SetCoorMap" methode="SetCoorMap"> 
+<param name="mfg" type="long" default="TypCoordGal"/>
+</attribute>
+<attribute name="SetCoorMapChr" methode="SetCoorMap"> 
+<param name="ctype" type="char*"/>
+</attribute>
+<attribute name="SetCalibrationFactor" methode="SetCalibrationFactor"> 
+<param name="fac" type="double" default="1."/>
+</attribute>
+<attribute name="SetTestFlag" methode="SetTestFlag"> 
+<param name="tflg" type="bool" default="false"/>
+<param name="badflg" type="long" default="FlgToiAll"/>
+</attribute>
+<attribute name="SetTestMin" methode="SetTestMin"> 
+<param name="tmin" type="bool" default="false"/>
+<param name="vmin" type="double" default="-1.e30"/>
+</attribute>
+<attribute name="SetTestMax" methode="SetTestMax"> 
+<param name="tmax" type="bool" default="false"/>
+<param name="vmax" type="double" default="+1.e30"/>
+</attribute>
+<connection>
+<input name="Coord1In"/>
+<input name="Coord2In"/>
+<input name="BoloIn"/>
+</connection>
+</processor>
+
+<processor name="map2toi" class="Map2TOI" include="map2toi.h">   
+<init>
+<param name="sph" type="string"/>
+</init>
+<attribute name="SetBad" methode="SetBad"> 
+<param name="flg" type="long" default="FlgToiOut"/>
+</attribute>
+<attribute name="SetEquinox" methode="SetEquinox"> 
+<param name="actualyear" type="double" default="2000"/>
+</attribute>
+<attribute name="SetCoorIn" methode= "SetCoorIn"> 
+<param name="mfg" type="long" default="TypCoordGalStd"/>
+</attribute>
+<attribute name="SetCoorInChr" methode="SetCoorIn"> 
+<param name="ctype" type="char*"/>
+</attribute>
+<attribute name="SetCoorMap" methode="SetCoorMap"> 
+<param name="mfg" type="long" default="TypCoordGal"/>
+</attribute>
+<attribute name="SetCoorMapChr" methode="SetCoorMap"> 
+<param name="ctype" type="char*"/>
+</attribute>
+<connection>
+<input name="Coord1In"/>
+<input name="Coord2In"/>
+<output name="Coord1Out"/>
+<output name="Coord2Out"/>
+<output name="BoloOut"/>
+</connection>
+</processor>
+
+<processor name="flag2map" class="FLAG2Map" include="flag2map.h">   
+<init>
+<param name="map" type="string"/>
+<param name="wmap" type="string" default="NULL"/>
+</init>
+<attribute name="SetEquinox" methode="SetEquinox"> 
+<param name="actualyear" type="double" default="2000"/>
+</attribute>
+<attribute name="SetCoorIn" methode= "SetCoorIn"> 
+<param name="mfg" type="long" default="TypCoordGalStd"/>
+</attribute>
+<attribute name="SetCoorInChr" methode="SetCoorIn"> 
+<param name="ctype" type="char*"/>
+</attribute>
+<attribute name="SetCoorMap" methode="SetCoorMap"> 
+<param name="mfg" type="long" default="TypCoordGal"/>
+</attribute>
+<attribute name="SetCoorMapChr" methode="SetCoorMap"> 
+<param name="ctype" type="char*"/>
+</attribute>
+<attribute name="SetCalibrationFactor" methode="SetCalibrationFactor"> 
+<param name="fac" type="double" default="1."/>
+</attribute>
+<attribute name="SetTestFlag" methode="SetTestFlag"> 
+<param name="tflg" type="bool" default="false"/>
+<param name="badflg" type="long" default="FlgToiAll"/>
+</attribute>
+<attribute name="SetTestMin" methode="SetTestMin"> 
+<param name="tmin" type="bool" default="false"/>
+<param name="vmin" type="double" default="-1.e30"/>
+</attribute>
+<attribute name="SetTestMax" methode="SetTestMax"> 
+<param name="tmax" type="bool" default="false"/>
+<param name="vmax" type="double" default="+1.e30"/>
+</attribute>
+<connection>
+<input name="Coord1In"/>
+<input name="Coord2In"/>
+<input name="BoloIn"/>
+</connection>
+</processor>
+
+<processor name="rztoiproc" class="RzTOIProc" include="rztoi.h">   
+<init>
+<param name="w1" type="int" default="4096"/>
+<param name="w2" type="int" default="128"/>
+<param name="nmax" type="int" default="20"/>
+</init>
+<attribute name="SetOutPPF" methode="SetOutPPF"> 
+<param name="ppfname" type="string"/>
+</attribute>
+<connection>
+<input name="in"/>
+<output name="out"/>
+</connection>
+</processor>
+
+<processor name="rzsimpletoiproc" class="RzSimpleTOIProc" include="rztoi.h">   
+<init>
+<param name="wsz" type="int" default="1024"/>
+<param name="fact" type="double" default="1.0"/>
+</init>
+<connection>
+<input name="in"/>
+<output name="out"/>
+</connection>
+</processor>
+
+<processor name="noisegen" class="NoiseGen" include="noisegen.h">   
+<connection>
+<output name="noise"/>
+</connection>
+</processor>
+
+<processor name="noisegengauss" class="NoiseGenGauss" include="noisegen.h">   
+<init>
+<param name="sigma" type="float"/>
+</init>
+<connection>
+<output name="noise"/>
+</connection>
+</processor>
+
+<processor name="noisegen00F" class="NoiseGenOOF" include="noisegen.h">   
+<init>
+<param name="fknee" type="float"/>
+<param name="sigma" type="float"/>
+</init>
+<connection>
+<output name="noise"/>
+</connection>
+</processor>
+
+<processor name="meanvarestimator" class="MeanVarEstimator" include="meanvarestim.h">   
+<init>
+<param name="nsamp" type="int"/>
+</init>
+<attribute name="doNotLookAt" methode="doNotLookAt"> 
+<param name="flag" type="long" default="FlgToiAll"/>
+</attribute>
+<connection>
+<input name="signal"/>
+<output name="mean"/>
+<output name="variance"/>
+</connection>
+</processor>
+
+
+
+<!-- processeur fictif de demo -->
 <processor name="demopipe" class="DemoPipe" include="demopipe.h">   
 
@@ -49,25 +243,4 @@
 </processor>
 
-<processor name="fitsreader" class="FITSTOIReader" include="fitstoirdr.h">   
-<init>
-<param name="fn" type="string" default="test.fits"/>
-</init>
-
-<connection>
-</connection>
-
-</processor>
-
-<processor name="fitswriter" class="FITSTOIWriter" include="fitstoiwtr.h">   
-<init>
-<param name="fn" type="string"/>
-</init>
-
-<connection>
-</connection>
-
-</processor>
-
-
 </processors>
 