Index: trunk/SophyaLib/Manual/piapp.tex
===================================================================
--- trunk/SophyaLib/Manual/piapp.tex	(revision 2248)
+++ trunk/SophyaLib/Manual/piapp.tex	(revision 2253)
@@ -222,4 +222,6 @@
 #  Surface representation of a matrix
 surf mtx1 colbr32
+# Contour representation of a matrix
+contour mtx1 'colrj32 normalline ncont=7'
 #  3D representation of points using a PAW like command
 n/plot nt31.z%y%x ! ! win
@@ -356,4 +358,5 @@
 \newpage
 \section{piapp command reference}
+\label{piappcmdref}
 This section contains the description of piapp commands. This information
 is available on-line, through the help command, or through a graphic
@@ -433,5 +436,5 @@
 The {\bf PIHisto2DTools}, shown in the figure \ref{figh2dtools} can be 
 used to control and change the display caracteristics of 2D histograms.
-PIHisto2DTools can be activated using {\tt Alt<O>} on a 
+PIHisto2DTools can be activated 
 either using {\tt Alt<O>} on a PIScDrawWdg, when the active 
 drawer is a PIHisto2DDrawer, or through the generic drawer tool 
@@ -452,5 +455,5 @@
 The {\bf PIContourTools}, shown in the figure \ref{figconttools} can be 
 used to control and change the caracteristics of contour displays.
-PIContourTools can be activated using {\tt Alt<O>} on a 
+PIContourTools can be activated  
 either using {\tt Alt<O>} on a PIScDrawWdg, when the active 
 drawer is a PIContDrawer, or through the generic drawer tool 
@@ -467,4 +470,63 @@
 
 
+
+Both drawing options  (e.g. color, line type, fonts...) and contour 
+determination parameters (e.g. contour number and levels) are controlled 
+by {\bf PIContourTools}. 
+
+\subsection{Drawing options}
+The top choices in {\bf PIContourTools} 
+concern the color map (left choice) or color (right choice) of the contours.
+If a color map has been chosen, it is used to give each contour a color 
+(according to its level). If no color map has been chosen, contours may be 
+given a color using the left choice box. 
+
+Contour are by default traced by lines. 
+Alternatively (or in addition) the user may ask to trace them by markers 
+or to put numeric labels (with the contour's level) aside the contour. 
+These options are enabled/disabled by the {\tt LineON}, {\tt MarkerON} and {\tt LabelON} 
+buttons from {\bf PIContourTools}. 
+
+Options may be recovered ({\tt GetAtt}) or set ({\tt SetAtt})
+from/to a drawer. Setting an option which adds to the screen will be immediately visible 
+whereas unsetting it requires a {\tt Refresh} to be visible.  
+
+
+\subsection{Contour options}
+The contouring routines in {\tt spiapp} are based on a hack of the {\tt GNUPlot} 
+routines. Contours are determined from a grid of values 
+using an interpolation scheme. Three schemes may be used
+(selected by the left menu) : 
+\begin{enumerate}
+\item Linear interpolation (default), selected by the  {\tt Int. Lin.} option  
+\item A cubic spline algorithm, selected by the  {\tt CubicSpl} option 
+\item A 2d BSpline algorihm, selected by the  {\tt B-Spline} option
+\end{enumerate}
+ 
+Contour levels and number are automatically 
+determined by the program.  They may be specified differently,  
+ through command-line options 
+(see section \ref{piappcmdref} for the help of the contour/ntcont commands)
+or the lower part of the {\bf PIContourTools} window. 
+
+The user may specify one  of the following alternatives : 
+\begin{enumerate}
+\item the number of contour (their level beeing automatically set). 
+To do this, select {\tt LevelNum} in the right menu and enter the contour number 
+in the left box below.
+\item the levels of the contours, through an array of numerical values 
+(e.g. 1,4,6,9,27,4.5 will result in 6 contour lines being drawn, if possible and necessary). 
+To do this, select {\tt LevelDisc} and enter the contour number (left box) 
+and the values (right box) separated by ``{\tt ,}''.
+\item the levels of the contours through an initial (lower) value and an increment.
+For this, select {\tt LevelInc} and enter the contour number (left box)
+and the initial value and increment in the right box, as above.
+\item come back to the default situation, by choosing {\tt LevelAuto}
+\end{enumerate}
+
+Once these options are set, it is necessary the the program recomputes 
+the contour lines. This is commanded by the {\tt SetParm} button. 
+
+
 \newpage
 \addcontentsline{toc}{section}{Index}